<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_WarningDistribution ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_WarningDistribution extends AbstractStructArrayBase
{
    /**
     * The Distribution
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_WarningDistribution[]
     */
    public $Distribution;
    /**
     * Constructor method for ArrayOfJP_WarningDistribution
     * @uses ArrayOfJP_WarningDistribution::setDistribution()
     * @param \StructType\JP_WarningDistribution[] $distribution
     */
    public function __construct(array $distribution = array())
    {
        $this
            ->setDistribution($distribution);
    }
    /**
     * Get Distribution value
     * @return \StructType\JP_WarningDistribution[]|null
     */
    public function getDistribution()
    {
        return $this->Distribution;
    }
    /**
     * Set Distribution value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_WarningDistribution[] $distribution
     * @return \ArrayType\ArrayOfJP_WarningDistribution
     */
    public function setDistribution(array $distribution = array())
    {
        foreach ($distribution as $arrayOfJP_WarningDistributionDistributionItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_WarningDistributionDistributionItem instanceof \StructType\JP_WarningDistribution) {
                throw new \InvalidArgumentException(sprintf('The Distribution property can only contain items of \StructType\JP_WarningDistribution, "%s" given', is_object($arrayOfJP_WarningDistributionDistributionItem) ? get_class($arrayOfJP_WarningDistributionDistributionItem) : gettype($arrayOfJP_WarningDistributionDistributionItem)), __LINE__);
            }
        }
        $this->Distribution = $distribution;
        return $this;
    }
    /**
     * Add item to Distribution value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_WarningDistribution $item
     * @return \ArrayType\ArrayOfJP_WarningDistribution
     */
    public function addToDistribution(\StructType\JP_WarningDistribution $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_WarningDistribution) {
            throw new \InvalidArgumentException(sprintf('The Distribution property can only contain items of \StructType\JP_WarningDistribution, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Distribution[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_WarningDistribution|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_WarningDistribution|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_WarningDistribution|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_WarningDistribution|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_WarningDistribution|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Distribution
     */
    public function getAttributeName()
    {
        return 'Distribution';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_WarningDistribution
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
